//+----------------------------------------------------------------------------+
//|                                             control_recycle_synthetic.mq4  |
//|                                                                   noloxe  |
//+----------------------------------------------------------------------------+

#property copyright " noloxe 2015"
#property description "     ."
#property description "             .\n"
#property description "   ,  ;"
#property description "    =    ;"
#property description "    () =    ;"
#property description " depo_symbol =   ;"
#property description " koeff =      ;"
#property description " print_PF_formul =    ."


enum choice0
{no=0,yes=1};
input choice0 sound=yes;

enum choice1
{
c=0,  //   
s=1,  //   
f=2,  //   
};
input choice1 comm_symb_form=s;

extern double koeff=1.2;
extern string depo_symbol="$";
extern bool print_PF_formul=false;


bool i2;
double slepage=30,allsumm;
int i, cnt2, flag,pf_all,fs,j,a,totalOrders,needClose,cnt0;
string clic,text,PFtext,name,st;
color cl=clrDarkGreen,clBack;

string pf_formul [];
string pf_symbols [];
string pf_comment [];
double pf_stoploss [];
double pf_takeprofit [];
double pf_profit [];
double pf_margin [];
int pf_howorders [];
int pf_needClose [];
int TICKETS [];
int TICKETS_pf [];

int eiOffsetY;       //    
int eiStepY = 17;    //     
int eiX1Row;         //  X  
int cr = 3;          // 3 -   , 1    



string symbol_perevorot;
int cmd;
double GlavLot1;
double Price;
string comm;
int ticket12;
int Error;
double price_ask;
double price_bid;



int init()
   {
   DeleteObjects();
   Comment (" ");
   DefinePF();
   eiOffsetY=(pf_all+1)*17;
   if (pf_all>0)
      {
      CalcMargin();
      DrawAll ();
      }
   EventSetTimer (1);
   return(0);
   }


int deinit()
   {
   EventKillTimer();
   DeleteObjects();
   Comment (" ");
   return(0);
   }


void OnTimer()
{

////    ,     /
if (needClose==1 && pf_all>0) {PFneedClose ();}

////         4
if (MathAbs(totalOrders-OrdersTotal())>=4) 
   {
   EventKillTimer();
   init();
   }

if (pf_all>0)
   {
   CalcProfit();
   allsumm=0;
   for(cnt2=0; cnt2<pf_all; cnt2++)
         {
         allsumm=allsumm+pf_profit[cnt2];
         if (pf_profit[cnt2]>=0) cl=DarkGreen;
         else cl=Red;
         PFtext=DoubleToStr(pf_profit[cnt2],2)+depo_symbol;
         LabelTextChange(0,name="SC"+IntegerToString(cnt2,2,'0'),PFtext,cl);
         }
   cl=DarkGreen;
   PFtext=": "+DoubleToStr(allsumm,2)+depo_symbol;
   LabelTextChange(0,name="SC"+IntegerToString(cnt2+1,2,'0'),PFtext,cl);
   }
else
   {
   PFtext="  .";
   SetLabel("SC"+IntegerToString(cnt2+1,2,'0'),PFtext,cl,eiX1Row+142,eiOffsetY-(cnt2+1)*eiStepY,cr,fs=10);
   }
return;
}



void CalcProfit()
{
////  
cnt0=0;
for(i=0;i<pf_all;i++)
   {
      allsumm=0;
      for(cnt2=0; cnt2<pf_howorders[i]; cnt2++)
         {
         {i2=false;while (i2==false){i2=OrderSelect(TICKETS_pf [cnt0], SELECT_BY_TICKET);}}
         cnt0=cnt0+1;
         allsumm=allsumm+OrderProfit()+OrderSwap()+OrderCommission();
         }
      pf_profit[i]=allsumm;
   
////                      
      if (allsumm!=0 && ((pf_stoploss[i]!=0 && allsumm<=pf_stoploss[i]) || (pf_takeprofit[i]!=0 && allsumm>=pf_takeprofit[i])))
         {
         pf_needClose[i]=1;
         needClose=1;
         }
   }
}


void CalcMargin()
{
////    ,   
cnt0=0;
for(i=0;i<pf_all;i++)
   {
   allsumm=0;
   string symb="";
   string OrderFormul="";
   string znakF="+";
      for(cnt2=0; cnt2<pf_howorders[i]; cnt2++)
         {
         {i2=false;while (i2==false){i2=OrderSelect(TICKETS_pf [cnt0], SELECT_BY_TICKET);}}
         cnt0=cnt0+1;
         pf_comment[i]=OrderComment();
         symb=symb+OrderSymbol()+" ";
         allsumm=allsumm+OrderLots()*MarketInfo(OrderSymbol(),MODE_MARGINREQUIRED);
         if (OrderType()==OP_BUY) znakF="+";
         else znakF="-";
         
         OrderFormul = OrderFormul+OrderSymbol()+"="+znakF+DoubleToStr(OrderLots(),2)+" ";
         }
   pf_margin[i]=allsumm;
   StringTrimRight (symb);
   StringReplace (symb,"USD","");
   pf_symbols[i]=symb;
   pf_formul[i]=OrderFormul;
   if (print_PF_formul==true) Print (OrderFormul);
   }
}


void DefinePF()
{
////       (  ,    )
int magic;
datetime time0=0;
comm="";

ArrayResize(TICKETS_pf,0);
flag=0;
pf_all=0;
totalOrders=OrdersTotal();     
if (totalOrders>0)
      {
      ArrayResize(TICKETS,totalOrders);
      for(i=0;i<totalOrders;i++)
         {
         {i2=false;while (i2==false){i2=OrderSelect(i, SELECT_BY_POS, MODE_TRADES);}}
         TICKETS [i]=OrderTicket();
         }
      ArraySort(TICKETS);
      }

      for(i=0;i<totalOrders;i++)
         {
            {i2=false;while (i2==false){i2=OrderSelect(TICKETS [i], SELECT_BY_TICKET);}}
            if(OrderType()!=OP_BUY && OrderType()!=OP_SELL) continue;
            
                        if (time0==0) 
                              {
                              time0=OrderOpenTime();
                              magic=OrderMagicNumber();
                              comm=OrderComment();
                              flag=1;
                              j=ArrayRange(TICKETS_pf,0)+1; 
                              ArrayResize(TICKETS_pf,j);
                              TICKETS_pf[j-1]=TICKETS [i];
                              continue;
                              }
            if (OrderOpenTime()-time0<=30)
               {
               //if (magic==OrderMagicNumber()&& comm==OrderComment())
               if (magic==OrderMagicNumber())
                              {
                              time0=OrderOpenTime();
                              j=ArrayRange(TICKETS_pf,0)+1; 
                              ArrayResize(TICKETS_pf,j);
                              TICKETS_pf[j-1]=TICKETS [i];
                              flag=flag+1;
                              continue;
                              }
               time0=OrderOpenTime();
               continue;
               }
            if (flag>1 && totalOrders>i+1) 
               {
               pf_all=pf_all+1;
               ArrayResize(pf_howorders,pf_all);
               pf_howorders[pf_all-1]=flag;
               time0=OrderOpenTime();
               magic=OrderMagicNumber();
               comm=OrderComment();
               flag=1;
               j=ArrayRange(TICKETS_pf,0)+1; 
               ArrayResize(TICKETS_pf,j);
               TICKETS_pf[j-1]=TICKETS [i];
               continue;
               }
            if (flag>1 && totalOrders==i+1) 
               {
               pf_all=pf_all+1;
               ArrayResize(pf_howorders,pf_all);
               pf_howorders[pf_all-1]=flag;
               flag=1;
               continue;
               }            
            if (flag==1 && totalOrders>i+1)
               {
               time0=OrderOpenTime();
               magic=OrderMagicNumber();
               comm=OrderComment();
               flag=1;
               j=ArrayRange(TICKETS_pf,0); 
               TICKETS_pf[j-1]=TICKETS [i];
               continue;
               }
            if (flag==1 && totalOrders==i+1)
               {
               flag=1;
               j=ArrayRange(TICKETS_pf,0)-1;
               ArrayResize(TICKETS_pf,j);
               continue;
               }
         }
      if (flag>1) 
         {
         pf_all=pf_all+1;
         ArrayResize(pf_howorders,pf_all);
         pf_howorders[pf_all-1]=flag;
         }
      if (pf_all>0)
         {
         ArrayResize(pf_profit,pf_all);
         ArrayResize(pf_comment,pf_all);
         ArrayResize(pf_margin,pf_all);
         ArrayResize(pf_symbols,pf_all);
         ArrayResize(pf_takeprofit,pf_all);
         ArrayResize(pf_stoploss,pf_all);
         ArrayResize(pf_formul,pf_all);
         ArrayResize(pf_needClose,pf_all);
         ArrayFill(pf_needClose,0,pf_all,0);
         }
}



void DrawAll ()
{
///  
allsumm=0;
for(cnt2=0; cnt2<pf_all; cnt2++)
   {
   ///  +  
   if (comm_symb_form==0) PFtext=pf_comment[cnt2]+" ("+DoubleToStr(pf_margin[cnt2],2)+")";
   if (comm_symb_form==1) PFtext=pf_symbols[cnt2]+" ("+DoubleToStr(pf_margin[cnt2],2)+")";
   if (comm_symb_form==2) PFtext=pf_formul[cnt2]+" ("+DoubleToStr(pf_margin[cnt2],2)+")";
   SetLabel("TX"+IntegerToString(cnt2,2,'0'),PFtext,cl,eiX1Row+210,eiOffsetY-cnt2*eiStepY,cr,fs=10);
   ///   
   allsumm=allsumm+pf_profit[cnt2];
   PFtext=DoubleToStr(pf_profit[cnt2],2)+depo_symbol;
   SetLabel("SC"+IntegerToString(cnt2,2,'0'),PFtext,cl,eiX1Row+142,eiOffsetY-cnt2*eiStepY,cr,fs=10);
   /// 
   clBack=clrPaleGreen;
   SetEditLabel("TP"+IntegerToString(cnt2,2,'0'),DoubleToStr(pf_takeprofit[cnt2],2),cl,eiX1Row+138,eiOffsetY-(cnt2-1)*eiStepY,cr,fs=9,clBack);
   /// 
   clBack=clrLightPink;
   SetEditLabel("SL"+IntegerToString(cnt2,2,'0'),DoubleToStr(pf_stoploss[cnt2],2),cl,eiX1Row+69,eiOffsetY-(cnt2-1)*eiStepY,cr,fs=9,clBack);
   }

PFtext=": "+DoubleToStr(allsumm,2)+depo_symbol;
SetLabel("SC"+IntegerToString(cnt2+1,2,'0'),PFtext,cl,eiX1Row+142,eiOffsetY-(cnt2+1)*eiStepY,cr,fs=10);
}


void SetEditLabel(string nm,string tx,color cvet,int xd,int yd,int ,int,color ) 
  {
   if(ObjectFind(nm)<0) ObjectCreate(nm,OBJ_EDIT,0,0,0);
   ObjectSetText(nm,tx,fs);
   ObjectSet(nm,OBJPROP_COLOR,cl);
   ObjectSet(nm,OBJPROP_XDISTANCE,xd);
   ObjectSet(nm,OBJPROP_YDISTANCE,yd);
   ObjectSet(nm,OBJPROP_CORNER,cr);
   ObjectSet(nm,OBJPROP_FONTSIZE,fs);
   ObjectSet(nm,OBJPROP_BGCOLOR,clBack);
   ObjectSet(nm,OBJPROP_ALIGN,ALIGN_CENTER);
   ObjectSet(nm,OBJPROP_BORDER_COLOR,clrDarkGray);
   ObjectSet(nm,OBJPROP_XSIZE,65);
  }


void SetLabel(string nm,string tx,color cvet,int xd,int yd,int ,int ) 
  {
   if(ObjectFind(nm)<0) ObjectCreate(nm,OBJ_LABEL,0,0,0);
   ObjectSetText(nm,tx,fs);
   ObjectSet(nm,OBJPROP_COLOR,cl);
   ObjectSet(nm,OBJPROP_XDISTANCE,xd);
   ObjectSet(nm,OBJPROP_YDISTANCE,yd);
   ObjectSet(nm,OBJPROP_CORNER,cr);
   ObjectSet(nm,OBJPROP_FONTSIZE,fs);
  }

void DeleteObjects() 
  {
  for(i=0; i<10; i++) 
     {
        for(j=0; j<10; j++)
           { 
           ObjectDelete("SC"+i+j);
           ObjectDelete("TP"+i+j);
           ObjectDelete("SL"+i+j);
           ObjectDelete("TX"+i+j);
           }
     }
  }


//+------------------------------------------------------------------+
//|                                              |
//+------------------------------------------------------------------+
bool LabelTextChange( long ,   // ID 
                      string , //  
                      string,  // 
                      color)
  {
   ResetLastError();
   if(!ObjectSetString(0,name,OBJPROP_TEXT,PFtext))
     {
      Print(__FUNCTION__,
            ":    !   = ",GetLastError());
      return(false);
     }
   ObjectSet(name,OBJPROP_COLOR,cl);
   return(true);
  }


//+------------------------------------------------------------------+ 
//|    " "                            | 
//+------------------------------------------------------------------+ 
bool TextGet(string ,        //  
                  long,  // ID  
                  string ) //   
  { 
   ResetLastError(); 
   if(!ObjectGetString(0,clic,OBJPROP_TEXT,0,PFtext )) 
     { 
      Print(__FUNCTION__, 
            ":    !   = ",GetLastError()); 
      return(false); 
     } 
   return(true); 
  } 


//+------------------------------------------------------------------+ 
//| ChartEvent function                                              | 
//+------------------------------------------------------------------+ 
void OnChartEvent(const int id,         //     
                  const long& lparam,   //    long 
                  const double& dparam, //    double 
                  const string& sparam) //    string 
{ 
      clic=sparam;
//---    
   if(id==CHARTEVENT_OBJECT_ENDEDIT) 
     { 
      TextGet(clic,0,PFtext);
      if(StringFind(clic,"SL",0)!=-1)
         {
         StringReplace (clic,"SL","");
         a=StrToInteger(clic);
         if (a>pf_all)return;
         pf_stoploss[a]=StrToDouble(PFtext);
         if (pf_stoploss[a]>=pf_profit[a]) {pf_stoploss[a]=0;}
         
         PFtext=DoubleToStr(pf_stoploss[a],2);
         LabelTextChange(0,name=sparam,PFtext,cl);
         return;
         }
      if(StringFind(clic,"TP",0)!=-1)
         {
         StringReplace (clic,"TP","");
         a=StrToInteger(clic);
         if (a>pf_all)return;
         pf_takeprofit[a]=StrToDouble(PFtext);
         if (pf_takeprofit[a]<=pf_profit[a]) {pf_takeprofit[a]=0;}
         
         PFtext=DoubleToStr(pf_takeprofit[a],2);
         LabelTextChange(0,name=sparam,PFtext,cl);
         return;
         }
     }
//---      
   if(id==CHARTEVENT_OBJECT_CLICK) 
     { 
      if(StringFind(clic,"SC",0)!=-1)
         {
         StringReplace (clic,"SC","");
         a=StrToInteger(clic);
         if (a>pf_all)return;
         text="? "+"\n"+"\n"+pf_symbols[a]+"\n"+": "+pf_profit[a];
         if(MessageBox(text,"!",MB_YESNO|MB_ICONINFORMATION)==IDNO) return;
         pf_needClose[a]=1;
         needClose=1;
         return;
         }
      if(StringFind(clic,"TX",0)!=-1)
         {
         StringReplace (clic,"TX","");
         a=StrToInteger(clic);
         if (a>pf_all)return;
         text="? "+"\n"+"\n"+pf_symbols[a]+"\n"+": "+pf_profit[a]+"\n"+": "+koeff;
         if(MessageBox(text,"!",MB_YESNO|MB_ICONINFORMATION)==IDNO) return;
         Perevorot ();
         return;
         }
     } 
}


void Perevorot ()
{
pf_needClose[a]=1;
needClose=1;
flag=0;

for(int cnt3=0; cnt3<a; cnt3++)
   {
   flag=flag+pf_howorders[cnt3];
   }
for(int i3=0; i3<pf_howorders[cnt3]; i3++)
   {
   {i2=false;while (i2==false){i2=OrderSelect(TICKETS_pf [flag], SELECT_BY_TICKET);}}

   if(OrderType()==OP_BUY) cmd=OP_SELL;
   else cmd=OP_BUY;
   symbol_perevorot=OrderSymbol();
   GlavLot1=NormalizeDouble(koeff*OrderLots(),2);
   comm=OrderComment()+"*"+DoubleToStr(koeff,2);
   OpenOrd();

   flag++;
   }
EventKillTimer();
init();
}



void OpenOrd ()
{
ticket12=-1;
Error=0;
ResetLastError();

while (ticket12<0)
         {
         if (cmd==OP_BUY) {Price=MarketInfo(symbol_perevorot,MODE_ASK);}
         else {Price=MarketInfo(symbol_perevorot,MODE_BID);}
         //Print (symbol_perevorot," ",cmd," ",GlavLot1," ",comm);
         
         ticket12=OrderSend(symbol_perevorot,cmd,GlavLot1,Price,slepage,0,0,comm,0,0,Green);
            if (ticket12>0) {break;}
            
            Error=GetLastError();
            switch(Error)
               {
               case 135: Print(" .   ..");
                  RefreshRates();
                  continue;
               case 138: Print(" .   ..");
                  RefreshRates();
                  continue;
               case 136: Print(" .   ..");
                  while(RefreshRates()==false)
                     Sleep(1);
                  continue;
               case 128: Print("  .  ..");
                  while(RefreshRates()==false)
                     Sleep(1);
                  continue;
               case 146: Print("  .  ..");
                  Sleep(1);
                  RefreshRates();
                  continue;
               case 137: Print(" .  ..");
                  Sleep(500);
                  RefreshRates();
                  continue;
               case 134: Print(" ,   1,2..");
                  GlavLot1=NormalizeDouble(GlavLot1/1.2,2);
                  continue;               
               case 130: Print(" /!");
                  Sleep(500);
                  RefreshRates();
                  continue;                
               case 2 : Print(" .");            
                  break;        
               case 5 : Print("   .");            
                  break;
               case 64: Print(" .");            
                  break;
               case 133:Print(" ");           
                  break;
               default: Print("  ",Error, "...");
                  Sleep(500);
                  RefreshRates();
                  continue;       
               }      
         }
}



void PFneedClose ()
{
////  ,    
for(i=pf_all-1;i>-1;i--)
   {
   if (pf_needClose[i]==0) continue;
   a=i;
   Close_PF();
   a=i+1;
   cnt0=pf_all-i-1;
   if (cnt0>0)
      {
      ArrayCopy(pf_stoploss,pf_stoploss,i,a,cnt0);
      ArrayCopy(pf_takeprofit,pf_takeprofit,i,a,cnt0);
      pf_stoploss[pf_all-1]=0; 
      pf_takeprofit[pf_all-1]=0;
      }
   }

ArrayFill(pf_needClose,0,pf_all,0);
needClose=0;
if (sound==1) PlaySound("alert2.wav");

EventKillTimer();
init();
}


void Close_PF()
{
allsumm=0;
flag=0;
for(int cnt3=0; cnt3<a; cnt3++)
   {
   flag=flag+pf_howorders[cnt3];
   }
for(int i3=0; i3<pf_howorders[cnt3]; i3++)
   {
   {i2=false;while (i2==false){i2=OrderSelect(TICKETS_pf [flag], SELECT_BY_TICKET);}}
   if (OrderCloseTime()==0)
      {
      price_ask=MarketInfo(OrderSymbol(),MODE_ASK);
      price_bid=MarketInfo(OrderSymbol(),MODE_BID);
         if(OrderType()==OP_BUY)
            {i2=false; while (i2==false){i2=OrderClose(TICKETS_pf [flag],OrderLots(),price_bid,slepage,Green);}}
         if(OrderType()==OP_SELL)
            {i2=false; while (i2==false){i2=OrderClose(TICKETS_pf [flag],OrderLots(),price_ask,slepage,Red);}}  
      
      {i2=false;while (i2==false){i2=OrderSelect(TICKETS_pf [flag], SELECT_BY_TICKET);}}
      }
   allsumm=allsumm+OrderProfit()+OrderSwap()+OrderCommission();
   flag++;
   }
Print (" : ",pf_symbols[a], ": ", allsumm);
}